<?php

namespace mcg76\world;

use pocketmine\command\Command;
use pocketmine\command\CommandSender;
use pocketmine\command\CommandExecutor;
use pocketmine\plugin\PluginBase;
use pocketmine\utils\TextFormat;
use pocketmine\Player;
use pocketmine\Server;
use pocketmine\utils\Config;
use pocketmine\level\Position;
use pocketmine\level\Level;
use pocketmine\level\Explosion;
use pocketmine\event\block\BlockEvent;
use pocketmine\event\block\BlockPlaceEvent;
use pocketmine\event\block\BlockBreakEvent;
use pocketmine\event\entity\EntityMoveEvent;
use pocketmine\event\entity\EntityMotionEvent;
use pocketmine\event\entity\EntityDamageEvent;
use pocketmine\event\block\SignChangeEvent;
use pocketmine\event\player\PlayerInteractEvent;
use pocketmine\event\player\PlayerMoveEvent;
use pocketmine\event\Listener;
use pocketmine\math\Vector3 as Vector3;
use pocketmine\math\Vector2 as Vector2;
use pocketmine\event\player\PlayerJoinEvent;
use pocketmine\event\player\PlayerQuitEvent;
use pocketmine\event\player\PlayerRespawnEvent;
use pocketmine\event\player\PlayerLoginEvent;
use pocketmine\network\protocol\AddMobPacket;
use pocketmine\network\protocol\AddEntityPacket;
use pocketmine\network\protocol\UpdateBlockPacket;
use pocketmine\block\Block;
use pocketmine\block\WallSign;
use pocketmine\event\server\DataPacketReceiveEvent;
use pocketmine\event\server\DataPacketSendEvent;
use pocketmine\network\protocol\DataPacket;
use pocketmine\network\protocol\Info;
use pocketmine\network\protocol\LoginPacket;
use pocketmine\level\generator\Generator;
use pocketmine\utils\Utils;
use pocketmine\utils\Binary;

use mcg76\world\map\Forest;
use mcg76\world\map\Mountains;
use mcg76\world\map\Desert;
use mcg76\world\map\DryDesert;
use mcg76\world\map\GrassHills;
use mcg76\world\map\Winter;
//use mcg76\world\map\SuperFlat;
use mcg76\world\map\WaterWorld;
use mcg76\world\map\Islands;
use mcg76\world\map\Volcano;
use mcg76\world\map\SkyGrids;

/**
 * MCG76 CustomWorld PlugIn
 *
 * Copyright (C) 2014 minecraftgenius76
 * YouTube Channel: http://www.youtube.com/user/minecraftgenius76
 *
 * @author MCG76
 *        
 */
class CustomWorldPlugIn extends PluginBase implements CommandExecutor {
	
	/**
	 * OnLoad
	 * (non-PHPdoc)
	 *
	 * @see \pocketmine\plugin\PluginBase::onLoad()
	 */
	public function onLoad() {
	}
	
	/**
	 * OnEnable
	 *
	 * (non-PHPdoc)
	 *
	 * @see \pocketmine\plugin\PluginBase::onEnable()
	 */
	public function onEnable() {
		$this->enabled = true;	
		Generator::addGenerator ( Forest::class, "forest" );
		Generator::addGenerator ( Mountains::class, "mountains" );
		Generator::addGenerator ( Desert::class, "desert" );
		Generator::addGenerator ( DryDesert::class, "drydesert" );
		Generator::addGenerator ( GrassHills::class, "grasshills" );
		Generator::addGenerator ( Winter::class, "winter" );
		//Generator::addGenerator ( SuperFlat::class, "superflat" );		
		Generator::addGenerator ( Islands::class, "islands" );
		Generator::addGenerator ( Volcano::class, "volcano" );
		Generator::addGenerator ( SuperFlat::class, "superflat");
		Generator::addGenerator ( SkyGrids::class, "skygrids" );
		
		$this->log ( "- WorldGenerators - Enabled!" );
	}
	
	/**
	 * OnDisable
	 * (non-PHPdoc)
	 *
	 * @see \pocketmine\plugin\PluginBase::onDisable()
	 */
	public function onDisable() {
		$this->enabled = false;
		$this->log ( "WorldGenerators - Disabled" );
	}
	
	/**
	 * Logging util function
	 *
	 * @param unknown $msg        	
	 */
	private function log($msg) {
		$this->getLogger ()->info ( $msg );
	}
}
