<?php

namespace mcg76\world\map;

use pocketmine\level\generator\Generator;
use pocketmine\level\ChunkManager;
use pocketmine\math\Vector3;
use pocketmine\utils\Random;
use pocketmine\block\Block;

/**
 * MCG76 SkyGrids
 *
 * Copyright (C) 2014 minecraftgenius76
 * YouTube Channel: http://www.youtube.com/user/minecraftgenius76
 *
 @author minecraftgenius76@gmail.com
 *
 */

// modified version 
// Additional Credits: shoghicp original skygrid

class SkyGrids extends Generator{
	private $level, $options, $random, $floatSeed, $total, $gridlength;
	private $peblocks = [];
			
	public function __construct(array $options = []){
		$this->pe = new PEBlock();
		$this->gridlength = 2;
		$this->options = $options;
		$this->peblocks = [
			Block::STONE => 120,
			Block::GRASS => 80,
			Block::DIRT => 20,
			Block::STILL_WATER => 9,
			Block::SAND => 20,
			Block::GRAVEL => 10,
			Block::GOLD_ORE => 10,
			Block::GLOWSTONE => 89,
			Block::JACK_O_LANTERN => 91,
			Block::STONE_BRICK => 98,
			Block::CHEST => 54,
			Block::LOG => Block::LOG,			
			Block::LOG2 => Block::LOG2,			
			Block::IRON_ORE => 15,
			Block::COAL_ORE => 40,
			Block::RED_MUSHROOM_BLOCK => 100,
			Block::LEAVES => 40,
			Block::GLASS => 1,
			Block::LAPIS_ORE => 21,
			Block::SANDSTONE => 24,
			Block::LEAVES => 18,
			Block::COBWEB => 30,
			Block::TALL_GRASS => 3,
			Block::DEAD_BUSH => 3,
			Block::WOOL => 25,
			Block::DANDELION => 2,
			Block::POPPY => 2,
			Block::BROWN_MUSHROOM => 2,
			Block::RED_MUSHROOM => 2,
			Block::TNT => 2,
			Block::BOOKSHELF => 3,
			Block::MOSS_STONE => Block::MOSS_STONE,
			Block::OBSIDIAN => Block::OBSIDIAN,
			Block::CHEST => 1,
			Block::MONSTER_SPAWNER => 1,
			Block::DIAMOND_ORE => 1,
			Block::REDSTONE_ORE => 8,
			Block::ICE => 4,
			Block::SNOW_BLOCK => 8,
			Block::SPONGE => 19,
			Block::LAPIS_BLOCK => 22,
			Block::CACTUS => 1,
			Block::CLAY_BLOCK => 20,
			Block::SUGARCANE_BLOCK => 15,
			Block::PUMPKIN => 5,
			Block::MELON_BLOCK => Block::MELON_BLOCK,
			Block::BEDROCK => 26,
			Block::MYCELIUM => 15
		];
	}
	
	
	public function getName() : string{
		return "skygrids";
	}
	
	public function getSettings() : array{
		return $this->options;
	}
	
	public function init(ChunkManager $level, Random $random){
		$this->level = $level;
		$this->random = $random;
		$this->floatSeed = $this->random->nextFloat();
		$this->total = 0;
	}
		
	public function generateChunk(int $chunkX, int $chunkZ){
		$this->random->setSeed((int) (($chunkX * 0xdead + $chunkZ * 0xbeef) * $this->floatSeed));		
		$chunk = $this->level->getChunk($chunkX, $chunkZ);		
		for($y = 0; $y < 128; $y += $this->gridlength){
			for($z = 0; $z < 6; $z += $this->gridlength){
				for($x = 0; $x < 6; $x += $this->gridlength){					
					$b = array_rand ( $this->peblocks);
					$blockId = $this->peblocks [$b];					
					if($blockId === Block::WOOL){
						$chunk->setBlockId($x, $y, $z, $blockId);
						$chunk->setBlockData($x, $y, $z, $this->random->nextInt() & 0xf);
					}elseif($blockId === 6 or $blockId === 31 or $blockId === 32 or $blockId === 37 or $blockId === 38 or $blockId === 39 or $blockId === 40 or $blockId === 83){
						$chunk->setBlockId($x, $y, $z, 3);
						$chunk->setBlockId($x, $y + 1, $z, $blockId);
						if($blockId === 83){
							$chunk->setBlockId($x + 1, $y, $z, 9);
							$chunk->setBlockId($x - 1, $y, $z, 2);
						}
					}elseif($blockId === 83){
						$chunk->setBlockId($x, $y, $z, 12);
						$chunk->setBlockId($x, $y + 1, $z, $blockId);
						$chunk->setBlockId($x, $y - 1, $z, $blockId);
					}else{
						$chunk->setBlockId($x, $y, $z, $blockId);
					}
				}
			}
		}
	}
	
	public function populateChunk(int $chunkX, int $chunkZ){

	}
	
	public function getSpawn() : Vector3{
		return new Vector3(128.5, 64, 128.5);
	}
}
